package Leer;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ParserEmpleados {
	
	private Empleados[] empleados;
	private File file;
	
	public boolean parse() {
        /** Parsed controla si se han podido parsear los datos. Inicialmente a false */
        boolean parsed = false;
        /** Inicializamos a null el array de países */
        empleados = null;
        try {
            /** Obtenemos una referencia al DocumentBuilderFactory necesaria para parsear mediante DOM */
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            /** Obtenemos una referencia al DocumentBuilder necesaria para parsear mediante DOM */
            DocumentBuilder builder = factory.newDocumentBuilder();
            /** Obtenemos una referencia al Document parseando mediante DOM */
            file = new File("src/Package/Empleados.xml");
            System.out.println(file.getAbsolutePath());
            Document dom = builder.parse(file);
            /** Obtenemos el elemento raíz del documento */
            Element root = dom.getDocumentElement();
            NodeList items = root.getElementsByTagName("empleado");
            empleados = new Empleados[items.getLength()];
            /** Recorremos cada uno de los nodos */
            for (int i = 0; i < items.getLength(); i++) {
                /** Obtenemos el nodo de la posición i */
            	
                Node item = items.item(i);
                
                Element el = (Element) item;
                
                int id = Integer.parseInt(el.getAttribute("id"));
                String apellido = el.getElementsByTagName("apellido").item(0).getTextContent();
                String dep = el.getElementsByTagName("dep").item(0).getTextContent();
                float salario = Float.parseFloat(el.getElementsByTagName("salario").item(0).getTextContent());
                /** Con los datos obtenidos, creamos el objeto Country en la posición i del array */
                empleados[i] = new Empleados(id,apellido,dep,salario);
            }
            /** Si hemos llegado hasta aquí, podemos asegurar que el documento xml ha sido parseado correctamente */
            parsed = true;
        } catch (ParserConfigurationException pce) {
        	System.out.println("PCE");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return parsed;
    }

    
    public Empleados[] getCountries() {
        return this.empleados;
    }
}
